<template>
  <div class="virtual-objects">
    <q-page padding>
      <h6>Application Component</h6>

      <div class="q-gutter-md q-pa-md">
        <q-card
          v-for="artifact in artifacts"
          :key="artifact.name"
          class="my-card"
        >
          <q-card-section>
            <div class="text-h6">{{ artifact.name }}</div>
          </q-card-section>

          <q-card-section>
            <div><strong>Description:</strong> {{ artifact.description }}</div>
            <div><strong>Version:</strong> {{ artifact.version }}</div>
            <div><strong>API Version:</strong> {{ artifact.apiVersion }}</div>
            <div><strong>App Version:</strong> {{ artifact.appVersion }}</div>
            <div><strong>Type:</strong> {{ artifact.type }}</div>
          </q-card-section>
        </q-card>
      </div>
    </q-page>

    <!-- Details Dialog -->
    <!-- <q-dialog v-model="showPopover" persistent>
      <q-card>
        <q-card-section>
          <div class="text-h6">Details: {{ currentVO.name }}</div>
          <div class="q-mt-md">
            <p><strong>Artifact:</strong> {{ currentVO.artifact.ref }}</p>
            <p><strong>Type:</strong> {{ currentVO.artifact.spec.type }}</p>
            <p><strong>Implementer:</strong> 
              {{ currentVO.artifact.spec.implementer }}</p>
            <p><strong>Target Name:</strong> 
              {{ currentVO.artifact.spec.target.name }}</p>
            <p><strong>Target Version:</strong>
               {{ currentVO.artifact.spec.target.version }}</p>
          </div>
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="Close" color="primary" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog> -->
  </div>
</template>

<script setup lang="ts">
import { onMounted } from 'vue';
import { QPage, QCard, QCardSection } from 'quasar';
import { useFetchArtifacts } from '../hooks/artifacts';

const { artifacts, fetchArtifacts } = useFetchArtifacts();

// const showPopover = ref(false);
// const currentVO = ref({});

onMounted(async () => {
  await fetchArtifacts('HELM');
});

// function showDetails(vo: VirtualObject) {
//   currentVO.value = vo;
//   showPopover.value = true;
// }
</script>

<style scoped>
.virtual-objects .my-card {
  width: 200px;
  /* Adjust size as needed */
}

.q-gutter-md > .q-card {
  display: inline-block;
  /* Arrange cards in a grid */
}
</style>
